/* -------------------------------------------------------------------------- 
 * Copyright (c) 2018-2019 Kneron Inc. All rights reserved.
 *
 *      Name:    main.c
 *      Purpose: Kneron NCPU
 *
 *---------------------------------------------------------------------------*/


#include <string.h>
#include "kneron_mozart.h"
#include "cmsis_os2.h"
#include "ipc.h"
#include "base.h"
#include "kdpio.h"
#include "dbg.h"
#include "cpu_ops_ex.h"
#include "post_processing_ex.h"
#include "pre_processing_ex.h"

void main_init(void);

void cpu_processing_add(void)
{
    kdpio_cpu_op_register(NEAREST_UPSAMPLE, nearest_upsample_cpu);
    kdpio_cpu_op_register(ZERO_UPSAMPLE, zero_upsample_cpu);
}

void pre_processing_add(void)
{
}

void post_processing_add(void)
{
    kdpio_post_processing_register(TINY_YOLO_V3, post_yolo_v3);
}

/*----------------------------------------------------------------------------
 *      Main: Initialize OS Kernel and NCPU SDK
 *---------------------------------------------------------------------------*/
int main(void)
{
    SystemCoreClockUpdate();

    osKernelInitialize();

    main_init();

    if (osKernelGetState() == osKernelReady) {
        osKernelStart();
    }

    while(1);
}

