#ifndef __BOARD_KDP520_EVB_H__
#define __BOARD_KDP520_EVB_H__

#include <kneron_mozart.h>

#define SYS_CAMERA_CORE_NAME        "sys_camera_core"

#define SENSOR_HMX2056              1
#define SENSOR_HMXRICA_RAW8         2

#define YES                         1
#define NO                          0

/* PRE-definition for board configuration */
#define V2K_ENABLE_HMX2056          1
#define V2K_ENABLE_OV9286           2
#define V2K_ENABLE_HMX2056_OV9286   3
#define V2K_ENABLE_HMXRICA          4
#define V2K_ENABLE_GC2145           5
#define V2K_ENABLE_SC132GS          6
#define V2K_ENABLE_GC2145_SC132GS   7
#define V2K_ENABLE_SC132GS_GC2145   8

#define V2K_ENABLE_TYPE             NO

/* 520 EVB board configuration */
#define I2C_0_ENABLE                NO
#define I2C_1_ENABLE                NO
#define I2C_2_ENABLE                NO
#define I2C_3_ENABLE                NO

#define CAM_ID_MAX                  2
#define IMGSRC_NUM                  CAM_ID_MAX

#define MIPI_CAM_RGB                0
#define MIPI_CAM_NIR                1

/* i2c platform data */
struct i2c_platform_data {
    unsigned long bus_speed;
};

/* lcdc platform data */

enum lcd_img_input_fmt {
    lcd_img_input_fmt_rgb565 = 0,
    lcd_img_input_fmt_rgb555,
    lcd_img_input_fmt_rgb444,
    lcd_img_input_fmt_rgb24,
    lcd_img_input_fmt_ycbcr422,
    lcd_img_input_fmt_ycbcr420,
    lcd_img_input_fmt_palette_8,
    lcd_img_input_fmt_palette_4,
    lcd_img_input_fmt_palette_2,
    lcd_img_input_fmt_palette_1,
};

struct fb_platform_data {
    unsigned long input_fmt; // refer to enum lcd_img_input_fmt definition
    unsigned short xres;
    unsigned short yres; 
};


#endif // __BOARD_KDP520_EVB_H__
