/** @file */
#ifndef __KDP_DDR_TABLE_H_
#define __KDP_DDR_TABLE_H_

/**
 * @defgroup Definition of DDR map
 *
 * @{
 */

/** KDP_DDR_BASE */
#define KDP_DDR_BASE                    0x60000000

/** Reserve for all_models.bin */
#define KDP_DDR_MODEL_RESERVED_END      0x62FFFFFF

/** DDR DDR HEAP HEAD for malloc */
#define KDP_DDR_HEAP_HEAD_FOR_MALLOC    0x63FCFFFF // heap grows upward

/** Reserve for system information */
#define KDP_DDR_BASE_SYSTEM_RESERVED    0x63FD0000 // reserved 191 KB

/** Reserve for fw_info.bin */
#define KDP_DDR_MODEL_INFO_TEMP         0x63FFF000 // 4KB

#define KDP_DDR_END                     0x63FFFFFF
/** @} */


/**
 * @defgroup Definition of snapshot image address and size
 * 
 * @{
 */
#define KDP_DDR_SNAPSHOT_RGB_IMG_SIZE       0x96000     /* 640x480x2(RGB565) */
#define KDP_DDR_SNAPSHOT_NIR_IMG_SIZE       0x4B000     /* 480x640x1(RAW8) */
#define KDP_DDR_SNAPSHOT_RGB_IMG_ADDR       0x62FFE000
#define KDP_DDR_SNAPSHOT_NIR_IMG_ADDR       0x6383B600
/** @} */

#ifdef BOARD_CUST1
#define KDP_DDR_DRV_LCM_RESERVED        0xEA600
#define KDP_DDR_DRV_LCM_START_ADDR      0x6302E000
#define KDP_DDR_DRV_LCM_ENDP1_ADDR      (KDP_DDR_DRV_LCM_START_ADDR + KDP_DDR_DRV_LCM_RESERVED //0x63118600

#define KDP_DDR_TEST_RGB_IMG_SIZE       0x96000 //640x480x2(RGB565)
#define KDP_DDR_TEST_NIR_IMG_SIZE       0x4B000 //480x640x1(RAW8)
#define KDP_DDR_TEST_START_ADDR         0x6311B600
#define KDP_DDR_TEST_RGB_IMG_ADDR       KDP_DDR_TEST_START_ADDR //0x6311B600
#define KDP_DDR_TEST_NIR_IMG_ADDR       (KDP_DDR_TEST_RGB_IMG_ADDR + KDP_DDR_TEST_RGB_IMG_SIZE) //0x631B1600
#define KDP_DDR_TEST_ENDP1_ADDR         (KDP_DDR_TEST_NIR_IMG_ADDR + KDP_DDR_TEST_NIR_IMG_SIZE) //0x631FC600

#define KDP_DDR_LAST_ADDR               0x63221E00
#endif

#endif
