#ifndef __KDP_FLASH_TABLE_H__
#define __KDP_FLASH_TABLE_H__

#define KDP_FLASH_BOOT_SPL_ADDR             0x00000000 // file=./flash_bin/boot_spl.bin
#define KDP_FLASH_BOOT_SPL_SIZE             0x00002000
#define KDP_FLASH_FW_SCPU_ADDR              0x00002000 // file=./flash_bin/fw_scpu.bin
#define KDP_FLASH_FW_SCPU_SIZE              0x00028000
#define KDP_FLASH_FW_NCPU_ADDR              0x0002A000 // file=./flash_bin/fw_ncpu.bin
#define KDP_FLASH_FW_NCPU_SIZE              0x00010000
#define KDP_FLASH_BOOT_CFG0_ADDR            0x0003A000 // file=./flash_bin/boot_cfg0.bin
#define KDP_FLASH_BOOT_CFG0_SIZE            0x00001000
#define KDP_FLASH_FW_RESERVED1_ADDR         0x0003B000 // file=./flash_bin/fw_reserved.bin
#define KDP_FLASH_FW_RESERVED1_SIZE         0x00006000
#define KDP_FLASH_FW_SCPU1_ADDR             0x00041000 // file=./flash_bin/fw_scpu1.bin
#define KDP_FLASH_FW_SCPU1_SIZE             0x00028000
#define KDP_FLASH_FW_NCPU1_ADDR             0x00069000 // file=./flash_bin/fw_ncpu1.bin
#define KDP_FLASH_FW_NCPU1_SIZE             0x00010000
#define KDP_FLASH_BOOT_CFG1_ADDR            0x00079000 // file=./flash_bin/boot_cfg1.bin
#define KDP_FLASH_BOOT_CFG1_SIZE            0x00001000
#define KDP_FLASH_FW_RESERVED2_ADDR         0x0007A000 // file=./flash_bin/fw_reserved.bin
#define KDP_FLASH_FW_RESERVED2_SIZE         0x00006000
#define KDP_FLASH_FID_MAP_ADDR              0x00080000 // file=./flash_bin/fid_map.bin
#define KDP_FLASH_FID_MAP_SIZE              0x00280000
#define KDP_FLASH_FW_INFO_ADDR              0x00300000 // file=./flash_bin/fw_info.bin
#define KDP_FLASH_FW_INFO_SIZE              0x000000B4
#define KDP_FLASH_ALL_MODELS_ADDR           0x00301000 // file=./flash_bin/all_models.bin
#define KDP_FLASH_ALL_MODELS_SIZE           0x00F6F600
#define KDP_FLASH_RGB_ADDR                  0x01271000 // file=./flash_bin/rgb.bin
#define KDP_FLASH_RGB_SIZE                  0x00096000
#define KDP_FLASH_NIR_ADDR                  0x01307000 // file=./flash_bin/nir.bin
#define KDP_FLASH_NIR_SIZE                  0x0004B000
#define KDP_FLASH_INF_ADDR                  0x01352000
#define KDP_FLASH_INF_SIZE                  0x00001000

/*-----------------------------------------------------------------------
*                 optional functions - snapshot section
*-----------------------------------------------------------------------*/
#define KDP_FLASH_SNAPSHOT_NUMS             (10)

#define KDP_FLASH_SNAPSHOT_IMG_00_ADDR      0x01353000
#define KDP_FLASH_SNAPSHOT_IMG_01_ADDR      (KDP_FLASH_SNAPSHOT_IMG_00_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_02_ADDR      (KDP_FLASH_SNAPSHOT_IMG_01_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_03_ADDR      (KDP_FLASH_SNAPSHOT_IMG_02_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_04_ADDR      (KDP_FLASH_SNAPSHOT_IMG_03_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_05_ADDR      (KDP_FLASH_SNAPSHOT_IMG_04_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_06_ADDR      (KDP_FLASH_SNAPSHOT_IMG_05_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_07_ADDR      (KDP_FLASH_SNAPSHOT_IMG_06_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_08_ADDR      (KDP_FLASH_SNAPSHOT_IMG_07_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_09_ADDR      (KDP_FLASH_SNAPSHOT_IMG_08_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_RGB_FDFR_ADDR     (KDP_FLASH_SNAPSHOT_IMG_09_ADDR+KDP_FLASH_RGB_SIZE)
#define KDP_FLASH_SNAPSHOT_IMG_NIR_FDFR_ADDR     (KDP_FLASH_SNAPSHOT_IMG_RGB_FDFR_ADDR+KDP_FLASH_RGB_SIZE)

///////////////////////////////////////////
/* optional functions - settings section */
///////////////////////////////////////////
#define KDP_FLASH_SETTINGS_ADDR             0x014CF000
#define KDP_FLASH_SETTINGS_SIZE             0x00002000

#define KDP_FLASH_LAST_ADDR                 0x014D1000

#endif

