/*
 * Kneron System Library
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#ifndef __KDP_IO_H__
#define __KDP_IO_H__

#include "io.h"

static inline void read_set_bit(volatile uint32_t addr, uint32_t bit)
{
    uint32_t tmp;
    tmp = inw(addr);
    tmp |= (1<<bit);
    outw(addr, tmp);
}

static inline void read_clear_bit(volatile uint32_t addr, uint32_t bit)
{
    uint32_t tmp;
    tmp = inw(addr);
    tmp &= ~(1<<bit);
    outw(addr, tmp);
}

#endif
