#ifndef __V2K_SUBDEV_H__
#define __V2K_SUBDEV_H__


#include "framework/v2k.h" 

#define v2k_subdev_call(sd, f, args...)                 \
    (!(sd) ? -KDP_FRAMEWORK_ERRNO_CTX : (((sd)->ops && (sd)->ops->f) ?   \
        (sd)->ops->f((sd) , ##args) : -KDP_FRAMEWORK_ERRNO_IOCTL))

struct v2k_subdev_enum_fmt {
    unsigned int index;
    unsigned int code;
};

struct v2k_subdev_ops;
struct pin_context;
struct v2k_subdev {
    const struct v2k_subdev_ops *ops;
    void *dev_priv;
};

struct v2k_subdev_ops {
    int (*s_power)(struct v2k_subdev *sd, int on);
    int (*reset)(struct v2k_subdev *sd);
    int (*s_stream)(struct v2k_subdev *sd, int enable);
    int (*enum_fmt)(struct v2k_subdev *sd, unsigned int index, unsigned int *fourcc);
    // Optional, can be set to NULL in this stage	
    int (*get_fmt)(struct v2k_subdev *sd, struct v2k_format *format);
    int (*set_fmt)(struct v2k_subdev *sd, struct v2k_format *format);
};

static inline void v2k_set_subdevdata(struct v2k_subdev *sd, void *p) {
    sd->dev_priv = p;
}

static inline void *v2k_get_subdevdata(const struct v2k_subdev *sd) {
    return sd->dev_priv;
}

void v2k_subdev_init(struct v2k_subdev *sd, const struct v2k_subdev_ops *ops);

struct sensor_device;
///* Initialize a v2k_subdev with data from an sensor_device struct */
void v2k_subdev_sensor_init(struct v2k_subdev *sd, struct sensor_device *sensor_dev,
        const struct v2k_subdev_ops *ops);

#endif
