/*
 * @name : v2k_subdev.c 
 * @brief : The base handler that will be needed for all sub devices
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */
#ifndef USE_KDP_CAMERA

#include <stdio.h> 
#include "framework/kdp_list.h" 
#include "media/camera/sensor.h"
#include "media/v2k_subdev.h"
#include "kmdw_console.h"


void v2k_subdev_init(struct v2k_subdev *sd, const struct v2k_subdev_ops *ops)
{
    sd->ops = ops;
    sd->dev_priv = NULL;
}

/* I2C Helper functions */
void v2k_subdev_sensor_init(struct v2k_subdev *sd, struct sensor_device *sensor_dev,
        const struct v2k_subdev_ops *ops)
{
    //DSG("[%s]", __func__);
    
    v2k_subdev_init(sd, ops);
    v2k_set_subdevdata(sd, sensor_dev);
    
    framework_drv_set_drvdata(&sensor_dev->pin_ctx, sd);
}
#endif
