#include "base.h"
#include "pinmux.h"
#include "kdrv_scu_ext.h"
#include "kmdw_console.h"
#include "board_kl520.h"


static void pinmux_set_board(void)
{
#if defined(BOARD_96)
    PINMUX_LC_PCLK_SET(PINMUX_LC_PCLK);SET_MASKED_BITS(SCU_EXTREG_LC_PCLK_IOCTRL, 0, 6, 7);
    PINMUX_LC_VS_SET(PINMUX_LC_VS);SET_MASKED_BITS(SCU_EXTREG_LC_VS_IOCTRL, 1, 6, 7);
    PINMUX_LC_HS_SET(PINMUX_LC_HS);SET_MASKED_BITS(SCU_EXTREG_LC_HS_IOCTRL, 1, 6, 7);
    PINMUX_LC_DE_SET(PINMUX_LC_DE);SET_MASKED_BITS(SCU_EXTREG_LC_DE_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA0_SET(PINMUX_LC_DATA0);SET_MASKED_BITS(SCU_EXTREG_LC_DATA0_IOCTRL, 0, 6, 7);
    PINMUX_LC_DATA1_SET(PINMUX_LC_DATA1);SET_MASKED_BITS(SCU_EXTREG_LC_DATA1_IOCTRL, 0, 6, 7);
    PINMUX_LC_DATA2_SET(PINMUX_LC_DATA2);SET_MASKED_BITS(SCU_EXTREG_LC_DATA2_IOCTRL, 0, 6, 7);
    PINMUX_LC_DATA3_SET(PINMUX_LC_DATA3);SET_MASKED_BITS(SCU_EXTREG_LC_DATA3_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA4_SET(PINMUX_LC_DATA4);SET_MASKED_BITS(SCU_EXTREG_LC_DATA4_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA5_SET(PINMUX_LC_DATA5);SET_MASKED_BITS(SCU_EXTREG_LC_DATA5_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA6_SET(PINMUX_LC_DATA6);SET_MASKED_BITS(SCU_EXTREG_LC_DATA6_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA7_SET(PINMUX_LC_DATA7);SET_MASKED_BITS(SCU_EXTREG_LC_DATA7_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA8_SET(PINMUX_LC_DATA8);SET_MASKED_BITS(SCU_EXTREG_LC_DATA8_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA9_SET(PINMUX_LC_DATA9);SET_MASKED_BITS(SCU_EXTREG_LC_DATA9_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA10_SET(PINMUX_LC_DATA10);SET_MASKED_BITS(SCU_EXTREG_LC_DATA10_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA11_SET(PINMUX_LC_DATA11);SET_MASKED_BITS(SCU_EXTREG_LC_DATA11_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA12_SET(PINMUX_LC_DATA12);SET_MASKED_BITS(SCU_EXTREG_LC_DATA12_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA13_SET(PINMUX_LC_DATA13);SET_MASKED_BITS(SCU_EXTREG_LC_DATA13_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA14_SET(PINMUX_LC_DATA14);SET_MASKED_BITS(SCU_EXTREG_LC_DATA14_IOCTRL, 1, 6, 7);
    PINMUX_LC_DATA15_SET(PINMUX_LC_DATA15);SET_MASKED_BITS(SCU_EXTREG_LC_DATA15_IOCTRL, 1, 6, 7);
    PINMUX_SD_CLK_SET(PINMUX_SD_CLK_LC_DATA16);SET_MASKED_BITS(SCU_EXTREG_SD_CLK_IOCTRL, 2, 6, 7);
    PINMUX_SD_CMD_SET(PINMUX_SD_CMD_LC_DATA17);SET_MASKED_BITS(SCU_EXTREG_SD_CMD_IOCTRL, 2, 6, 7);
#elif defined(BOARD_CUST1)
    PINMUX_SPI_WP_N_SET(0);
    PINMUX_SPI_HOLD_N_SET(0);
    PINMUX_LC_VS_SET(PINMUX_LC_VS_LCM_DB0);
    PINMUX_LC_HS_SET(PINMUX_LC_HS_LCM_DB1);
    PINMUX_LC_DE_SET(PINMUX_LC_DE_LCM_DB2);
    PINMUX_LC_DATA0_SET(PINMUX_LC_DATA0_LCM_DB3);
    PINMUX_LC_DATA1_SET(PINMUX_LC_DATA1_LCM_DB4);
    PINMUX_LC_DATA2_SET(PINMUX_LC_DATA2_LCM_DB5);
    PINMUX_LC_DATA3_SET(PINMUX_LC_DATA3_LCM_DB6);
    PINMUX_LC_DATA4_SET(PINMUX_LC_DATA4_LCM_DB7);
    PINMUX_LC_DATA5_SET(PINMUX_LC_DATA5_GPIO16);//TE PIN

    PINMUX_LC_DATA6_SET(PINMUX_LC_DATA6_UART2_TX);
    PINMUX_LC_DATA7_SET(PINMUX_LC_DATA7_UART2_RX);
    SCU_EXTREG_LC_DATA6_SET_dcsr(0);
    SCU_EXTREG_LC_DATA7_SET_dcsr(0);
    PINMUX_LC_DATA13_SET(PINMUX_LC_DATA13_GPIO2);
    PINMUX_LC_DATA14_SET(PINMUX_LC_DATA14_GPIO3);

//    PINMUX_LC_DATA8_SET(PINMUX_LC_DATA8_LCM_DB11);
//    PINMUX_LC_DATA9_SET(PINMUX_LC_DATA9_LCM_DB12);
//    PINMUX_LC_DATA10_SET(PINMUX_LC_DATA10_LCM_DB13);
//    PINMUX_LC_DATA11_SET(PINMUX_LC_DATA11_LCM_DB14);
//    PINMUX_LC_DATA12_SET(PINMUX_LC_DATA12_LCM_DB15);
//    PINMUX_LC_DATA13_SET(PINMUX_LC_DATA13_LCM_DB16);
//    PINMUX_LC_DATA14_SET(PINMUX_LC_DATA14_LCM_DB17);
    PINMUX_LC_DATA15_SET(PINMUX_LC_DATA15_LCM_SCn);
    PINMUX_SD_CLK_SET(PINMUX_SD_CLK_LCM_WR);
    PINMUX_SD_CMD_SET(PINMUX_SD_CMD_LCM_RS);
    PINMUX_SD_DATA0_SET(PINMUX_SD_DATA0_LCM_RD);
    PINMUX_SD_DATA1_SET(PINMUX_SD_DATA1_LCM_RESETn);
    // PINMUX_SD_DATA2_SET(PINMUX_SD_DATA2_LCM_BLCTRL);
    PINMUX_SD_DATA3_SET(PINMUX_SD_DATA3_LCM_TP_INT1);
#endif
#if defined(IMGSRC_IN_HAS_DPI)
    PINMUX_LC_DATA8_SET(PINMUX_LC_DATA8_DPI);
    PINMUX_LC_DATA9_SET(PINMUX_LC_DATA9_DPI);
    PINMUX_LC_DATA10_SET(PINMUX_LC_DATA10_DPI);
    PINMUX_LC_DATA11_SET(PINMUX_LC_DATA11_DPI);
    PINMUX_LC_DATA12_SET(PINMUX_LC_DATA12_DPI);
    PINMUX_LC_DATA13_SET(PINMUX_LC_DATA13_DPI);
    PINMUX_LC_DATA14_SET(PINMUX_LC_DATA14_DPI);
    PINMUX_LC_DATA15_SET(PINMUX_LC_DATA15_DPI);
    PINMUX_SD_CLK_SET(PINMUX_SD_CLK_DPI);
    PINMUX_SD_CMD_SET(PINMUX_SD_CMD_DPI);
    PINMUX_SD_DATA0_SET(PINMUX_SD_DATA0_DPI);
    PINMUX_SD_DATA1_SET(PINMUX_SD_DATA1_DPI);
#endif
}

void pinmux_init(void)
{
    pinmux_set_board();
}
