/*
 * @name : framework.c
 * @brief : The startup thread is responsible for the core initialization
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */
#ifdef V2K_ENABLE
#ifndef USE_KDP_CAMERA

#include <stdio.h>
#include <stdlib.h>
#include <cmsis_os2.h>
#include "framework/init.h"
#include "framework/framework_driver.h"
#include <framework/framework.h>
#include "utility.h"
#include "kmdw_console.h"


#define FLAG_FRAMEWORK_INIT_START   0x0011
#define FLAG_KERNEL_INIT_STOP       0x0012

//extern pf_entr entr_sectionn0$$Base;
//extern pf_entr entr_section0$$Limit;
extern pf_entr entr_section1$$Base;
extern pf_entr entr_section1$$Limit;
//extern pf_entr entr_section2$$Base;
//extern pf_entr entr_section2$$Limit;
extern pf_entr entr_section3$$Base;
extern pf_entr entr_section3$$Limit;
extern pf_entr entr_section4$$Base;
extern pf_entr entr_section4$$Limit;
extern pf_entr entr_section5$$Base;
extern pf_entr entr_section5$$Limit;
extern pf_entr entr_section6$$Base;
extern pf_entr entr_section6$$Limit;

static pf_entr *entrance_section_levels[] INITDATA = {
	//&entr_section0$$Base, &entr_section0$$Limit,
    &entr_section1$$Base, &entr_section1$$Limit,
    //&entr_section2$$Base, &entr_section2$$Limit,
    &entr_section3$$Base, &entr_section3$$Limit,
    &entr_section4$$Base, &entr_section4$$Limit,
    &entr_section5$$Base, &entr_section5$$Limit,
    &entr_section6$$Base, &entr_section6$$Limit,
};

static void INITTEXT _do_entrance_section(int level) 
{
	pf_entr *fn;
	for (fn = entrance_section_levels[level]; fn < entrance_section_levels[level + 1]; fn++) {
        if (*fn)
            (*fn)();
	}
}

void framework_init(void) 
{
    int level;
    
	framework_drv_init();

	//do_entrance_sections();  
	for (level = 0; level < (ARRAY_SIZE(entrance_section_levels)); level += 2) {
		_do_entrance_section(level);
	}    
}

int late_entrance(void) {
    DSG("late_entrance");

	return 0;
}
ARRANGE_ENTR_RO_SECTION(late_entrance, 6);

#endif
#endif
