/********************************************************************
 * Copyright (c) 2020 Kneron, Inc. All Rights Reserved.
 *
 * The information contained herein is property of Kneron, Inc.
 * Terms and conditions of usage are described in detail in Kneron
 * STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information.
 * NO WARRANTY of ANY KIND is provided. This heading must NOT be removed
 * from the file.
 ********************************************************************/

/**@addtogroup  KDRV_LCM  KDRV_LCM
 * @{
 * @brief       Kneron LCM driver
 * @copyright   Copyright (C) 2020 Kneron, Inc. All rights reserved.
 */
#ifndef __KDRV_LCM_H__
#define __KDRV_LCM_H__

#include "io.h"
#include "kneron_mozart.h"
#include "kdrv_display.h"

u8 kdrv_lcm_get_backlight(void);

kdrv_status_t kdrv_lcm_pressing(kdrv_display_t *display_drv, u32 addr);

kdrv_status_t kdrv_lcm_pressingnir(kdrv_display_t *display_drv, u32 addr);

kdrv_status_t kdrv_lcm_write_cmd(uint32_t base, unsigned char data);

kdrv_status_t kdrv_lcm_write_data(uint32_t base, unsigned char data);

unsigned int kdrv_lcm_read_data(uint32_t base);

uint32_t kdrv_lcm_get_db_frame(void);

#endif
/** @}*/
