/*
 * Kneron memory APIs
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#ifndef __KDP_MEMORY_H_
#define __KDP_MEMORY_H_

#include <stdint.h>

/**
 * @brief To initialize available DDR block 
 * @param start_addr the start address of DDR block
 * @param eed_addr the end address of DDR block
 */
void        kmdw_ddr_init(uint32_t start_addr, uint32_t end_addr);

/**
 * @brief to allocate DDR memory
 * @param numbtye size in byte
 * @return the address of allocated block
 */
uint32_t    kmdw_ddr_reserve(uint32_t numbyte);

#endif

