#include <string.h>
#include "kmdw_memory.h"
#include "kmdw_console.h"

/* ddr malloc direction : from tail(bigger address) to head (smaller) */

static uint32_t s_ddr_addr_tail = 0;
static uint32_t s_ddr_addr_boundary = 0;

#define ALIGN_BYTE 16
static uint32_t _align(uint32_t n);
    
uint32_t _align(uint32_t n) {
    return (n + ALIGN_BYTE - 1) & ~( ALIGN_BYTE - 1);
}

void kmdw_ddr_init(uint32_t start_addr, uint32_t end_addr)
{
    s_ddr_addr_tail = start_addr; //KDP_DDR_HEAP_HEAD_FOR_MALLOC+1 (address to the last used tail)
    s_ddr_addr_boundary = end_addr; //KDP_DDR_MODEL_RESERVED_END
}

uint32_t kmdw_ddr_reserve(uint32_t numbyte)
{
    uint32_t aligned_numbyte;
    if(numbyte == 0)
        return 0;
		
		if(s_ddr_addr_boundary == 0)
				return 0; //not initialized yet
    
    
    aligned_numbyte = _align(numbyte);
    
    s_ddr_addr_tail -= aligned_numbyte;    

    if(s_ddr_addr_tail <= s_ddr_addr_boundary)
    {
        err_msg("[ERR] ddr malloc over available bondary\n" ); 
        return 0; 
    }
    
    return s_ddr_addr_tail;
}
