/*
 * Kneron Main Entry driver
 *
 * Copyright (C) 2020 Kneron, Inc. All rights reserved.
 *
 */

#include "kneron_mozart.h"                // Device header
#include "cmsis_os2.h"                    // ARM::CMSIS:RTOS2:Keil RTX5

void main_init(int host_mode);
void console_entry(void);

/**
 * @brief main, main function
 */
int main(void) 
{
    SystemCoreClockUpdate();            // System Initialization
    osKernelInitialize();               // Initialize CMSIS-RTOS

    /* SDK main init */
    main_init(1);

    /* Application entry */
    console_entry();

    /* Start RTOS Kernel */
    if (osKernelGetState() == osKernelReady) {
        osKernelStart();
    }

    while(1) {
    }
}
